#!/usr/bin/env python
"""
  Test raboty s fajl. s-moj ext2.
  Demonstraciq prosmotra kornewogo kataloga i inod.
"""
from ext2_subr import *
import sys,time

imq0 = 'sdb2_ext2_2Mb.dat'
ofs0_sec=0

assert imq0.endswith('.dat')

set_whodn(imq0, ofs0_sec_=ofs0_sec)

superblok = read_superblok()
write_xxx('superblock.dat',superblok)

(block_size,ino_size,
  group_count,blocks_per_group,ino_per_group,
  ino_count,dlina_ino_tab,
  nr_bloka_gdt) = anal_superblok(superblok)

s_gdt = read_gdt()
write_xxx('gdt.dat',s_gdt)

root_dir,sootw = read_root_dir()
# Zapisywatx root_dir na disk ne nuvno - 
# podprog. read_root_dir w hode izwle`eniq
# sama zapisywaet 'root_dir.dat'.

# --------

for i in range(group_count):
 hh = analiz_gruppy(s_gdt,i)
 ino_tab = hh[2]  # Nomer na`alxnogo bloka tablicy inod dlq dannoj gruppy.
 for j in range(ino_per_group):
  print '# --------'
  nomer = ino_per_group*i+j+1  # Dlq korn. kat. i=0, j=1 -> nomer=2.
  print 'i,j=',i,j,'-> nomer=',nomer 
  s_inode = izwl_inode(ino_tab,j, otlad=True)
  resu = anal_inode(s_inode, otlad=True)
  if resu!=None:
   modif,siz,blocks,p = resu
   # write_xxx('inode%04d.dat' % (nomer,),s_inode)
   if nomer in sootw.keys():
    print 'nomer,imq=',nomer,repr(sootw[nomer])
   else:
    print 'nomer=',nomer,'- imq neizwestno !!!'
