"""
  Ob]ie podprog-my dlq analiza wseh fajlowyh sistem etc.
"""
from geral import printable_s

def set_razmer_klastera(razmer_klastera_):
 "razmer klastera - w bajtah."
 global razmer_klastera,sect_per_block
 assert razmer_klastera_%512==0
 sect_per_block = razmer_klastera_/512
 razmer_klastera = razmer_klastera_

def sozd_s_err():
 s='ERROR'
 for i in range(512-len(s)): s+=chr(0)
 return(s)

s_err=sozd_s_err()

def show16(s0):
 "Dlq otladki."
 s1 = s0[:16]
 s2 = 'show16: / '+printable_s(s1)+' / '
 for c in s1: s2 = s2+('%02X' % (ord(c),))+' '
 print s2

def set_whodn_(imq0_,ofs0_sec_=0):
 """
 imq0 - napr., '/dev/sdc' ili 'sdc.dat';
 ofs0_sec - sme]enie w sektorah dlq na`ala analiziruemoj oblasti,
 napr., 0 dlq MBR.
 """
 global imq0,ofs0_sec
 print 'set_whodn_: imq0,ofs0_sec = %s %08X' % (repr(imq0_),ofs0_sec_)
 imq0,ofs0_sec = imq0_,ofs0_sec_

def set_sect_per_block(sect_per_block_):
 global sect_per_block
 print 'set_sect_per_block: sect_per_block_=',sect_per_block_
 sect_per_block = sect_per_block_

def read_sect(n):
 """
 ~itaet sektor s zadannym sme]eniem;
 t.e. dlq 1-go sektora nado bratx n=0.
 """
 ofs_sec=ofs0_sec+n
 ofs = 512*ofs_sec
 print 'read_sect: ofs_sec,ofs= %08X %08X' % (ofs_sec,ofs)
 f0=open(imq0,'rb')
 errcode=0
 try:
  f0.seek(ofs)
 except:
  errcode=1
 if errcode==0:
  try:
   s=f0.read(512)
  except:
   errcode=2
 if errcode!=0:
  f2=open('errors.txt','ab')
  ss='read_sec: %08X %08X errcode=%d !!!' % (ofs_sec,n)
  print ss
  f2.write(ss+'\n')
  f2.close()
  s=s_err
 return(s,errcode)

def read_nesk_sect(n,n_sect=1, comment=None):
 ofs_sec=ofs0_sec+n
 smesc = 512*ofs_sec
 if not comment:
  print 'read_nesk_sect: n,smesc,n_sect=%08X %08X %d' % (n,smesc,n_sect)
 else:
  print 'read_nesk_sect: n,smesc,n_sect=%08X %08X %d / %s' % (n,smesc,n_sect,comment)
 f0=open(imq0,'rb')
 errcode=0
 try:
  f0.seek(smesc)
 except:
  errcode=1
  s=s_err*n_sekt
 if errcode==0:
  try:
   s=f0.read(512*n_sect)
  except:
   s=''
   for i in range(n_sect):
    si,errcode_ = read_sect(n+i)
    if errcode_!=0: errcode=2
    s+=si
 if errcode!=0:
  f2=open('errors.txt','ab')
  ss='read_nesk_sect: %08X %08X %d errcode=%d !!!' % (ofs_sec,n,n_sekt,errcode)
  print ss
  f2.write(ss+'\n')
  f2.close()
 return(s,errcode)

def read_xxx(ofs0_,dlina, otlad=True, comment=None):
 ofs0 = ofs0_sec*512+ofs0_
 if otlad:
  if not comment:
   print 'read_xxx: ofs0_,ofs0,ofs1=%08X %08X %08X' % (ofs0_,ofs0,ofs0+dlina)
  else:
   print 'read_xxx: ofs0_,ofs0,ofs1=%08X %08X %08X / %s' % (ofs0_,ofs0,ofs0+dlina,comment)
 f0=open(imq0,'rb')
 try:
  f0.seek(ofs0)
  s = f0.read(dlina)
  assert len(s)==dlina
  errcode=0
 except:
  s='' 
  errcode=1
 f0.close()
 return(s,errcode) 

def write_xxx(imq1,s):
 """
 Bez prowerki dliny, napr., zapis. dannye iz 
 wosstanawliwaemogo fajla.
 """
 f1=open(imq1,'wb')
 f1.write(s)
 f1.close()

def zapis_info(s):
 # print 'zapis_info:',repr(s)
 f2=open('tempor.htm','ab')
 f2.write(s+'\n')
 f2.close()

def read_blok(nr_bloka, otlad=False):
 """
 W ext2 ispolxz. termin "blok", w FAT i NTFS - "klaster",
 no funkcionalxno ih smysl odinakow.
 Wozmovna problema: w ext2 numeraciq blokow
 na`. s 1, a kak w FAT i NTFS - nado wyqsnitx, 
 i, esli s 0, wwesti korrekci; !
 """
 ofs_sect = nr_bloka*sect_per_block
 print 'read_blok: blok %d -> ofs_sect=0x%04X' % (nr_bloka,ofs_sect)
 s,errcode = read_nesk_sect(ofs_sect, n_sect=sect_per_block, comment='read_blok '+str(nr_bloka))
 assert errcode==0
 if otlad:
  show16(s)
  writ_blok(s,nr_bloka)
 return(s,errcode)

def writ_blok(s,nr_bloka):
 assert len(s)==razmer_klastera
 f1=open('blok_'+str(nr_bloka)+'.dat','wb'); f1.write(s); f1.close()

"""
def zapis_blok(n):
 s=read_blok(n)
 # if not ne0(s): return(None)
 f1=open('blok'+str(n)+'.dat','wb'); f1.write(s); f1.close()
"""

# --------

if __name__=='__main__':
 ss=dir()
 for s in ss:
  print s
